/* Ben Greear, System Programming, Spring 1997 */
/* assignment# 5, utilizing fork, execl, dup2, read, write, pipe,
   and signal (mostly) */

/* This program forks a child, which forks a child and execl's a 'sort' 
program.  The data is piped through each process, and the third child,
dup2's the pipe because 'sort' reads from stdin and writes to stdout.
*/

/*  Feel free to use/modify this code.  It does nothing useful, but may
    help you understand certain things (that was why I was assigned it)
    Questions:  email me:  greear@cs.uga.edu
*/

/*  Don't be a tool and turn this in as your own assignment btw.  */

#include <signal.h>
#include <sys/wait.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/resource.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/time.h>
#include <string.h>

/* try to sort out this pipe mess! */
#define READ  0
#define WRITE 1

/* catch the SIGPIPE signal, and handle it trivially */
void sig_handler(int signo) {
   printf("ERROR:  SIGPIPE signal caught.\n");
   exit(2);
}//sig_handler

/* catch the signal SIGPIPE */
int main(int argc, char* argv[]) {
   pid_t pid;
   int to_child[2], from_child[2]; //pipes
   char buf[512];

	/* set up signal catcher for SIGPIPE */
   signal(SIGPIPE, &sig_handler);

   /* pipes to connect parent to child1            */
   if ((pipe(to_child) < 0) || (pipe(from_child) < 0)) {
      perror("Pipe failed, main");
      return 1;
   }//if


   if ((pid = fork()) < 0) {
      perror("Fork failed, main");
      return 1;
   }//if
   else if (pid > 0) { //if we are the parent
	/* close pipe ends we do not need */
      if ((close(to_child[READ]) < 0) || (close(from_child[WRITE]) < 0)) {
	 perror("Close on the pipe, main parent");
	 return 1;
      }//if
      
      int len;

      printf("\nPrompt>"); //Show a prompt

           /* read from stdin, and write to pipe */
      while (gets(buf) != NULL) { //read a line
	 len = strlen(buf);
	 buf[len] = '\n';
         buf[len + 1] = 0; //add in the newline

		/* send the line down the pipe to child1 */
	 //printf("Got a line: %s", buf);
	 if (write(to_child[WRITE], buf, (len = strlen(buf))) != len) {
	    perror("Write failed, main parent");
	    return 1;
	 }//if

		/* read from the other pipe, should be stuff 
		   coming back from child1 */
	 //printf("About to read stuff from child1\n");
         if ((len = read(from_child[READ], buf, 511)) > 0) {
	    buf[len] = 0;
	    printf("%s\n", buf);
         }//if
	 if (len < 0) { //check error on read
	    perror("read failed");
	    return 1;
         }//if
         printf("Prompt>"); //Show a prompt
      }//while, do it line at a time

	/* close pipe ends we're done */
      if ((close(to_child[WRITE]) < 0) || (close(from_child[READ]) < 0)) {
	 perror("Close rest working ends of the pipes, main parent");
	 return 1;
      }//if

      waitpid(pid, NULL, 0); //wait on the first child to die
   }//if was the parent, else is the child
   else { //first generation child

      //printf("First gen child here.\n");
	/* close the ends of the pipe we do not need */
      if ((close(to_child[WRITE]) < 0) || (close(from_child[READ]) < 0)) {
	 perror("Close on the pipe");
	 return 1;
      }//if
      
      int len;

	/* read lines from the parent, originally from stdin */
      //printf("About to read lines from parent.\n");
      int tst;
      while ((tst = len = read(to_child[READ], buf, 511)) > 0) { 
	 pid_t child_2;
	 int to_second[2], from_second[2]; //pipes to connect child1 and child2

	 buf[len] = 0; //terminate the bugger
         //printf("Got a line from parent:  %s", buf);

	    /* now chop into single word-lines */
	 for (int i = 0; buf[i]; i++) {
	    if (buf[i] == ' ')
	       buf[i] = '\n';
	 }//for

		/* pipes to connect child1 to child2 */
         if ((pipe(to_second) < 0) || (pipe(from_second) < 0)) {
            perror("Pipe failed, child1");
            return 1;
         }//if

		/* child1 forking... */

	 if ((child_2 = fork()) < 0) {
	    perror("Second fork:");
	    return 2;
	 }//if
	 else if (child_2 > 0) { //parent of the third process then
		/* close ends we don't need */
	    //printf("In child2.\n");
            if ((close(to_second[READ]) < 0) || 
		(close(from_second[WRITE]) < 0)) {
   	       perror("Close on the pipes");
	       return 1;
            }//if

		/* write through pipe to child2 */
	    //printf("About to write to child2's pipe, in child1\n");
	    if (write(to_second[WRITE], buf, (len = strlen(buf))) != len) {
	       perror("Write failed, child1");
	       return 1;
	    }//if

		/* read from the other pipe, should be stuff
		   coming back from child2 */

		/* no more to be written to child2, close it */
            if (close(to_second[WRITE])) {
   	       perror("Close on the write pipe to child2");
	       return 1;
            }//if

	    char buf2[512];
	    int len2;
		/* read input from sort's output */
	    //printf("About to read from sort's output.\n");
            if ((len2 = read(from_second[READ], buf, 511)) > 0) {
	       buf[len2] = 0;

		/* get rid of newlines, make it a line once more */
	       for (int i = 0; i<len2; i++) {
		  if (buf[i] == '\n')
		     buf[i] = ' ';
	       }//for
            }//if
	    if (len2 < 0) {
	       perror("read failed");
	       return 1;
            }//if

		/* close read pipe to child2 */
            if (close(from_second[READ]) < 0) {
   	       perror("Close on read pipe from child2, in child1");
	       return 1;
            }//if

		/* write through pipe to parent */
	    //printf("About to write to parent.\n");
	    if (write(from_child[WRITE], buf, (len = strlen(buf))) != len) {
	       perror("Write failed, child1");
	       return 1;
	    }//if

		/* wait for child2 to die */
            waitpid(child_2, NULL, 0);
         }//if was child1, else is child2
	 else {
		/* close pipe ends we don't need */
            if ((close(to_second[WRITE]) < 0) || 
		(close(from_second[READ]) < 0)) {
   	       perror("Close on the pipes, child2");
	       return 1;
            }//if

	     	/* connect pipes to stdin and stdout for sort */
	    if ((dup2(to_second[READ], STDIN_FILENO) != STDIN_FILENO) ||
	        (dup2(from_second[WRITE], STDOUT_FILENO) != STDOUT_FILENO)) {
	       perror("Dup2");
	       return 1;
	    }//if

		/* run sort program */
	    if (execl("/usr/bin/sort", NULL) < 0) {
		perror("execl");
	        return 1;
	    }//if

		/* not sure if this is needed or not */
            if ((close(to_second[READ]) < 0) || 
		(close(from_second[WRITE]) < 0)) {
   	       perror("Close on the pipes");
	       return 1;
            }//if

            if ((close(STDIN_FILENO) < 0) || 
		(close(STDOUT_FILENO) < 0)) {
   	       perror("Close on stdin and stdout");
	       return 1;
            }//if

	 }//if was the second child
      }//while len was ok on the read

      if (tst < 0) {
	 perror("read");
	 return 1;
      }//else
   }//if was the second child
}/* main */
